﻿Main();

function Main() {
	var sheetNumber,
	maxNumberOfSheets = 3,
	allData = [],
	splitCharRows = "|",	
	splitCharColumns = ";";	
	
	var folder = Folder.selectDialog("Choose a Folder");
	if (folder != null) {
		$.writeln("==============");
		$.writeln("fsName - " + folder.fsName);
		var excelFileRoot = folder.fsName.replace("/Volumes/", "").replace(/\//g, ":");
		$.writeln("excelFileRoot - " + excelFileRoot);
		var excelFilePath = ‎excelFileRoot + ":Links:Master FES 2019 Final.xlsx";
		$.writeln("excelFilePath - " + excelFilePath);
		var csvPath = excelFileRoot + "/CSV files";
		$.writeln("csvPath - " + csvPath);
		
		var excelFile = new File(excelFilePath);
		if (excelFile.exists) {
			$.writeln("excelFile.exists");
			for (var i = 1; i <= maxNumberOfSheets; i++) {
				var data = GetDataFromExcelMac(excelFilePath, splitCharRows, splitCharColumns, sheetNumber);
				$.writeln("=====================================\rsheet #" + i + "\r" + data.toString());
				allData.push(data);
			}
		}
		
		$.writeln("=====================================\rAll Data: " + allData.toString());
	}
}

function GetDataFromExcelMac(excelFilePath, splitCharRows, splitCharColumns, sheetNumber) {
	if (File.fs != "Macintosh") return null;
	if (typeof splitCharRows === "undefined") var splitCharRows = "|";
	if (typeof splitCharColumns === "undefined") var splitCharColumns = ";";
	if (typeof sheetNumber === "undefined") var sheetNumber = "1";

	var appVersion,
	appVersionNum = Number(String(app.version).split(".")[0]);
	
	switch (appVersionNum) {
		case 14:
			appVersion = "CC 2019";
			break;
		case 13:
			appVersion = "CC 2018";
			break;
		case 12:
			appVersion = "CC 2017";
			break;
		case 11:
			appVersion = "CC 2015";
			break;
		case 10:
			appVersion = "CC 2014";
			break;			
		case 9:
			appVersion = "CC";
			break;		
		case 8:
			appVersion = "CS 6";
			break;
		case 7:
			if (app.version.match(/^7\.5/) != null) {
				appVersion = "CS 5.5";
			}
			else {
				appVersion = "CS 5";
			}
			break;
		case 6:
			appVersion = "CS 4";
			break;
		case 5:
			appVersion = "CS 3";
			break;
		case 4:
			appVersion = "CS 2";
			break;
		case 3:
			appVersion = "CS";
			break;			
		default:
		return null;
	}

	var as = 'tell application "Microsoft Excel"\r';
	as += 'open file \"' + excelFilePath + '\"\r';
	as += 'set theWorkbook to active workbook\r';
	as += 'set theSheet to sheet ' + sheetNumber + ' of theWorkbook\r';
	as += 'set theMatrix to value of used range of theSheet\r';
	as += 'set theRowCount to count theMatrix\r';
	as += 'set str to ""\r';
	as += 'set oldDelimiters to AppleScript\'s text item delimiters\r';
	as += 'repeat with countRows from 1 to theRowCount\r';
	as += 'set theRow to item countRows of theMatrix\r';
	as += 'set AppleScript\'s text item delimiters to \"' + splitCharColumns + '\"\r';
	as += 'set str to str & (theRow as string) & \"' + splitCharRows + '\"\r';
	as += 'end repeat\r';
	as += 'set AppleScript\'s text item delimiters to oldDelimiters\r';
	as += 'close theWorkbook saving no\r';
	as += 'end tell\r';
	as += 'tell application "Adobe InDesign ' + appVersion + '\"\r';
	as += 'tell script args\r';
	as += 'set value name "excelData" value str\r';
	as += 'end tell\r';
	as += 'end tell';
	
	if (appVersionNum > 5) { // CS4 and above
		app.doScript(as, ScriptLanguage.APPLESCRIPT_LANGUAGE, undefined, UndoModes.ENTIRE_SCRIPT);
	}
	else { // CS3 and below
		app.doScript(as, ScriptLanguage.APPLESCRIPT_LANGUAGE);
	}

	var str = app.scriptArgs.getValue("excelData");
	app.scriptArgs.clear();
	
	var tempArrLine, line,
	data = [],
	tempArrData = str.split(splitCharRows);
	
	for (var i = 0; i < tempArrData.length; i++) {
		line = tempArrData[i];
		if (line == "") continue;
		tempArrLine = line.split(splitCharColumns);
		data.push(tempArrLine);
	}
	
	return data;
}